# file: positionalAdd.py
# author: Bob Muller
#
# CS1101 Computer Science I
#
# How to add positional numerals.
#
# addDigits : int * int -> int * int
#
def addDigits(n, base):
  carryOut = n / base
  sum = n % base
  return (carryOut, sum)

# reverse : A list -> A list
#
def reverse(xs):
  n = len(xs)
  return [ xs[n - i - 1] for i in range(n) ]
  
# positionalAdd : int list * int list * int -> int list
#
def positionalAdd(ms, ns, base):
  assert len(ms) == len(ns)
  def repeat(ms, ns, carryIn, acc):
    if ms == []:
      return acc
    else:
      m = ms[0]
      n = ns[0]
      (carryOut, sum) = addDigits(m + n + carryIn, base)
      return repeat(ms[1:], ns[1:], carryOut, [sum] + acc)

  return repeat(reverse(ms), reverse(ns), 0, [])
